import random
# Use the function defined to work over 2D geometry
# and use them with the context "g2d"
import geometry_2d as g2d

N = int(input("Number of iterations? "))

print("Leibnitz")  # print a message
pi = 0
for n in range(0, N + 1):
    pi += (-1) ** n / (2 * n + 1)
pi = 4 * pi
print(pi)

print("Monte-Carlo")


def pi_by_montecarlo(number_of_points):
    inside = 0
    for t in range(0, number_of_points + 1):
        point = (random.random(), random.random())
        if g2d.inside_circle(point, (0, 0), 1):
            inside += 1
    return 4 * inside / number_of_points


pi_average = 0
nexp = 10
print("Trying ", nexp, "times")
for exp in range(0, nexp):
    pi_average += pi_by_montecarlo(N)
print(pi_average / nexp)

threshold = float(input("Threshold? "))
pi = 4
pi_next = pi + 4 * (-1 / 3)
n = 2
difference = abs(pi_next - pi)
while difference > threshold:
    pi = pi_next
    pi_next = pi + 4 * (-1) ** n / (2 * n + 1)
    print("pi(", n - 1, ")=", pi, " pi(", n, ")=", pi_next)
    difference = abs(pi_next - pi)
    n += 1
print(pi)
print("Number of needed iterations is ", n-1)
